Package com.smartgwt.client.widgets

# Class Window

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VLayout
com.smartgwt.client.widgets.Window

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasCloseClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMaximizeClickHandlers`, `HasMinimizeClickHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRestoreClickHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasMembersChangedHandlers`

Direct Known Subclasses:
  `AISortProgressDialog`, `AIWindow`, `ColorPicker`, `DateRangeDialog`, `Dialog`, `EditSearchWindow`, `FieldPickerWindow`, `ListPropertiesDialog`, `MultiGroupDialog`, `MultiSortDialog`, `Portlet`, `PrintWindow`, `TourWindow`

public class Window extends VLayout implements HasCloseClickHandlers, HasMaximizeClickHandlers, HasMinimizeClickHandlers, HasRestoreClickHandlers
A general purpose Window class for implementing dialogs, portlets, alerts, prompts, wizards and desktop-like windowing interfaces.

Windows can contain arbitrary Smart GWT components, configured via the `items` property. Windows may be `modal` or non-modal.

Windows provide a series of highly configurable and skinnable `autoChildren` including a header, various header controls, footer, and corner resizer.

The more specialized `Dialog` subclass of Window has additional functionality targetted at simple prompts and confirmations, such as buttons with default actions, and single-method `shortcuts` for common application dialogs.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Window()`
  `Window(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `HandlerRegistration`
  `addCloseClickHandler(CloseClickHandler handler)`
  Add a closeClick handler.
  `void`
  `addItem(Widget widget)`
  Adds a widget to the window.
  `void`
  `addItem(Canvas component)`
  Adds a widget to the window.
  `HandlerRegistration`
  `addMaximizeClickHandler(MaximizeClickHandler handler)`
  Add a maximizeClick handler.
  `void`
  `addMember(Canvas newMember)`
  Same as `Layout.addMember()`.
  `void`
  `addMember(Canvas newMember, Integer position)`
  Same as `Layout.addMember()`.
  `HandlerRegistration`
  `addMinimizeClickHandler(MinimizeClickHandler handler)`
  Add a minimizeClick handler.
  `HandlerRegistration`
  `addRestoreClickHandler(RestoreClickHandler handler)`
  Add a restoreClick handler.
  `void`
  `centerInPage()`
  Centers the Window in the page.
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `void`
  `close()`
  Close this window.
  `protected JavaScriptObject`
  `create()`
  `void`
  `flash()`
  Makes the window header flash if it's visible; if there's no header, or the header is hidden, makes the window body flash instead.
  `Boolean`
  `getAnimateMinimize()`
  Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
  `Boolean`
  `getAutoCenter()`
  If true, this Window widget will automatically be centered on the page when shown.
  `Boolean`
  `getAutoSize()`
  If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
  `Canvas`
  `getBody()`
  Body of the Window, where `contained components` or `loaded content` is shown.
  `String`
  `getBodyColor()`
  Color of the Window body.
  `String`
  `getBodyStyle()`
  Style of the Window body.
  `boolean`
  `getBringToFrontOnMouseUp()`
  Should this window automatically be shown at the top of the page's z-order and be brought to front via `Canvas.bringToFront()` whenever the user clicks it?
  `Boolean`
  `getCanDragReposition()`
  If true, this Window may be moved around by the user by dragging on the Window header.
  `Boolean`
  `getCanDragResize()`
  Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
  `Boolean`
  `getCanFocusInHeaderButtons()`
  If true, the user can give the header buttons focus (see `minimizeButton`, `maximizeButton`, `restoreButton` and `closeButton`).
  `ImgButton`
  `getCloseButton()`
  Button show in the header that will close this Window by calling `Window.closeClick()`.
  `ContentLayoutPolicy`
  `getContentLayout()`
  The layout policy that should be used for widgets within the Window body.
  `String`
  `getContentsType()`
  If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.
  `int`
  `getDefaultMinimizeHeight()`
  If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
  `Boolean`
  `getDismissOnEscape()`
  Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
  Windows with this setting will dismiss on Escape keypresses in any of the following cases: The window or one of its descendants has focus (and does not cancel the Escape keypress) The window is `modal`, and not itself masked.
  `Boolean`
  `getDismissOnOutsideClick()`
  If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
  Note: Applies only to modal windows.
  `String`
  `getEditProxyConstructor()`
  Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
  `String`
  `getFillSpaceStyleName()`
  Alternative style for the window used whenever `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `HLayout`
  `getFooter()`
  Optional footer for the window, providing space for controls such as the resizer and status bar.
  `int`
  `getFooterHeight()`
  The height of the footer, in pixels.
  `HLayout`
  `getHeader()`
  Header for the Window, based on an HLayout.
  `Img`
  `getHeaderBackground()`
  Img background component for the header, for gradient or image-based display
  `Img`
  `getHeaderIcon()`
  Header icon shown at left end of header by default.
  `Label`
  `getHeaderLabel()`
  Label that shows Window title in header.
  `String`
  `getHeaderSrc()`
  If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
  `String`
  `getHeaderStyle()`
  Style for the Window header.
  `String`
  `getHiliteBodyColor()`
  Highlight color for the Window body (shown when the body is flashed).
  `String`
  `getHiliteHeaderSrc()`
  If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
  `String`
  `getHiliteHeaderStyle()`
  Highlight style for the Window header.
  `Boolean`
  `getIsModal()`
  If true, when shown this Window will intercept and block events to all other existing components on the page.
  `Canvas[]`
  `getItems()`
  The contents of the Window body.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `ImgButton`
  `getMaximizeButton()`
  Button that will make this Window fill the browser via `maximize()`.
  `Boolean`
  `getMaximized()`
  Is this window maximized.
  `AnimationAcceleration`
  `getMinimizeAcceleration()`
  Default acceleration function for performing an animated minimize / maximize.
  `ImgButton`
  `getMinimizeButton()`
  ImgButton shown in the header that will minimize this Window by calling `minimize()`.
  `Boolean`
  `getMinimized()`
  Is this window minimized.
  `Integer`
  `getMinimizeHeight()`
  Height for the window when minimized.
  `Integer`
  `getMinimizeTime()`
  If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
  `Canvas`
  `getModalMask()`
  A ScreenSpan instance used to darken the rest of a page when a modal window is active.
  `int`
  `getModalMaskOpacity()`
  Controls the opacity of the modal mask displayed behind modal windows.
  `String`
  `getModalMaskStyle()`
  Specifies the CSS style for the modal mask.
  `Integer`
  `getOpacity()`
  Renders the widget to be partly transparent.
  `static Window`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `PanelPlacement`
  `getPlacement()`
  Where should the window be placed on the screen? Valid settings include `"fillScreen"`, `"fillPanel"`, `"halfScreen"` and `"none"`
  `String`
  `getPrintBodyStyle()`
  Style for the Window body in printed output.
  `String`
  `getPrintHeaderStyle()`
  CSS Style for header in printed output
  `EdgeName[]`
  `getResizeFrom()`
  When drag resizing is enabled via `canDragResize`, restricts resizes to only certain edges or corners.
  `ImgButton`
  `getResizer()`
  ImgButton-based resizer, shown in the footer.
  `ImgButton`
  `getRestoreButton()`
  ImgButton that restores the Window via `restore()`.
  `Boolean`
  `getShowBody()`
  If true, draw the body contents when this Window is drawn.
  `Boolean`
  `getShowCloseButton()`
  If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick()`.
  `Boolean`
  `getShowEdges()`
  `showEdges` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.
  `Boolean`
  `getShowFooter()`
  If true, show a footer for this Window, including resizer, statusBar, etc.
  `Boolean`
  `getShowHeader()`
  If true, show a `header` for this Window.
  `Boolean`
  `getShowHeaderBackground()`
  Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
  If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
  `Boolean`
  `getShowHeaderIcon()`
  If true, we show an icon on the left in the header.
  `Boolean`
  `getShowMaximizeButton()`
  If true, show a maximize button in the header - clicking it maximizes the Window
  `Boolean`
  `getShowMinimizeButton()`
  If true, show a minimize button in the header--clicking it minimizes the Window.
  `Boolean`
  `getShowModalMask()`
  If true, displays a translucent mask over the rest of the page when a modal window is displayed.
  `Boolean`
  `getShowResizer()`
  If true, show a button in the lower right corner that allows users to resize the Window.
  `Boolean`
  `getShowShadow()`
  Whether to show a drop shadow for this Canvas.
  `Boolean`
  `getShowStatusBar()`
  If true, show a statusBar for this Window, including resizer.
  `Boolean`
  `getShowTitle()`
  Show a title (typically just text) on the header for this window.
  `String`
  `getSrc()`
  A URL to load as content for the Window's body.
  `String`
  `getStatus()`
  Text to show in the status bar of the window (if one is visible)
  `Canvas`
  `getStatusBar()`
  Simple Canvas-based status bar, shown in the footer.
  `String`
  `getTitle()`
  Title for this Window, shown if `showTitle` is true in the `header` (if drawn).
  `Boolean`
  `getUseBackMask()`
  By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9.
  `void`
  `maximize()`
  Maximize the window.
  `void`
  `minimize()`
  Minimize the window.
  `static void`
  `preloadImages()`
  Preload primary window skin images
  `void`
  `removeItem(Canvas component)`
  Removes a widget from the window.
  `void`
  `restore()`
  Restores the window to its specified height and width after a call to `minimize()` or `maximize()`.
  `void`
  `revealChild(Canvas child)`
  Reveals the child Canvas passed in by showing it if it is currently hidden.
  `void`
  `revealChild(String childID)`
  Reveals the child Canvas passed in by showing it if it is currently hidden.
  `Window`
  `setAnimateMinimize(Boolean animateMinimize)`
  Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
  `Window`
  `setAutoCenter(Boolean autoCenter)`
  If true, this Window widget will automatically be centered on the page when shown.
  `Window`
  `setAutoSize(Boolean autoSize)`
  If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
  `Window`
  `setBodyColor(String bodyColor)`
  Color of the Window body.
  `Window`
  `setBodyDefaults(Map bodyDefaults)`
  Default properties for the body of the Window
  You can change the class-level bodyDefaults for all Windows by changing this item or set instance.body to be another object of properties to override for your instance only
  `Window`
  `setBodyStyle(String bodyStyle)`
  Style of the Window body.
  `Window`
  `setBringToFrontOnMouseUp(boolean bringToFrontOnMouseUp)`
  Should this window automatically be shown at the top of the page's z-order and be brought to front via `Canvas.bringToFront()` whenever the user clicks it?
  `Window`
  `setCanDragReposition(Boolean canDragReposition)`
  If true, this Window may be moved around by the user by dragging on the Window header.
  `Window`
  `setCanDragResize(Boolean canDragResize)`
  Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
  `Window`
  `setCanFocusInHeaderButtons(Boolean canFocusInHeaderButtons)`
  If true, the user can give the header buttons focus (see `minimizeButton`, `maximizeButton`, `restoreButton` and `closeButton`).
  `Window`
  `setContentLayout(ContentLayoutPolicy contentLayout)`
  The layout policy that should be used for widgets within the Window body.
  `void`
  `setContentLayout(String contentLayout)`
  Deprecated.
  use the other `setContentLayout()`
  `Window`
  `setContentsType(String contentsType)`
  If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.
  `Window`
  `setDefaultMinimizeHeight(int defaultMinimizeHeight)`
  If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
  `static void`
  `setDefaultProperties(Window windowProperties)`
  Class level method to set the default properties of this class.
  `Window`
  `setDismissOnEscape(Boolean dismissOnEscape)`
  Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
  Windows with this setting will dismiss on Escape keypresses in any of the following cases: The window or one of its descendants has focus (and does not cancel the Escape keypress) The window is `modal`, and not itself masked.
  `Window`
  `setDismissOnOutsideClick(Boolean dismissOnOutsideClick)`
  If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
  Note: Applies only to modal windows.
  `Window`
  `setEditProxyConstructor(String editProxyConstructor)`
  Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
  `Window`
  `setFillSpaceStyleName(String fillSpaceStyleName)`
  Alternative style for the window used whenever `placement` settings indicate the menu will be filling a portion of the screen or a panel.
  `void`
  `setFooterControls(Object... footerControls)`
  Array of members to show in the Window footer.
  `Window`
  `setFooterHeight(int footerHeight)`
  The height of the footer, in pixels.
  `void`
  `setHeaderControls(Object... headerControls)`
  Array of members to show in the Window header.
  `void`
  `setHeaderIcon(String imgSrc)`
  Sets the Window header icon.
  `void`
  `setHeaderIcon(String imgSrc, int width, int height)`
  Sets the Window header icon.
  `Window`
  `setHeaderIconDefaults(Map headerIconDefaults)`
  This is an object literal property block specifying the various properties of the headerIcon - the icon that appears at the top left of the window and is by default the Isomorphic logo.
  `void`
  `setHeaderIconProperties(Map headerIconProperties)`
  `Window`
  `setHeaderSrc(String headerSrc)`
  If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
  `Window`
  `setHeaderStyle(String headerStyle)`
  Style for the Window header.
  `Window`
  `setHiliteBodyColor(String hiliteBodyColor)`
  Highlight color for the Window body (shown when the body is flashed).
  `Window`
  `setHiliteHeaderSrc(String hiliteHeaderSrc)`
  If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
  `Window`
  `setHiliteHeaderStyle(String hiliteHeaderStyle)`
  Highlight style for the Window header.
  `Window`
  `setIsModal(Boolean isModal)`
  If true, when shown this Window will intercept and block events to all other existing components on the page.
  `Window`
  `setKeepInParentRect(Rectangle rectangle)`
  If Window.canDragReposition or Window.canDragRShowcaseDataesize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)? Can also be set to an array denoting an arbitrary Rectangle beyond which the window cannot be moved.
  `Window`
  `setKeepInParentRect(Boolean keepInParentRect)`
  If Window.canDragReposition or Window.canDragResize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)?
  `LogicalStructureObject`
  `setLogicalStructure(WindowLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Window`
  `setMaximized(Boolean maximized)`
  Is this window maximized.
  `Window`
  `setMinimizeAcceleration(AnimationAcceleration minimizeAcceleration)`
  Default acceleration function for performing an animated minimize / maximize.
  `Window`
  `setMinimized(Boolean minimized)`
  Is this window minimized.
  `Window`
  `setMinimizeHeight(Integer minimizeHeight)`
  Height for the window when minimized.
  `Window`
  `setMinimizeTime(Integer minimizeTime)`
  If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
  `Window`
  `setModalMaskOpacity(int modalMaskOpacity)`
  Controls the opacity of the modal mask displayed behind modal windows.
  `Window`
  `setModalMaskStyle(String modalMaskStyle)`
  Specifies the CSS style for the modal mask.
  `Window`
  `setOpacity(Integer opacity)`
  Renders the widget to be partly transparent.
  `Window`
  `setPlacement(PanelPlacement placement)`
  Where should the window be placed on the screen? Valid settings include `"fillScreen"`, `"fillPanel"`, `"halfScreen"` and `"none"`
  `Window`
  `setPrintBodyStyle(String printBodyStyle)`
  Style for the Window body in printed output.
  `Window`
  `setPrintHeaderStyle(String printHeaderStyle)`
  CSS Style for header in printed output
  `Window`
  `setResizeFrom(EdgeName... resizeFrom)`
  When drag resizing is enabled via `canDragResize`, restricts resizes to only certain edges or corners.
  `Window`
  `setShowBody(Boolean showBody)`
  If true, draw the body contents when this Window is drawn.
  `Window`
  `setShowCloseButton(Boolean showCloseButton)`
  If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick()`.
  `Window`
  `setShowEdges(Boolean showEdges)`
  `showEdges` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.
  `Window`
  `setShowFooter(Boolean showFooter)`
  If true, show a footer for this Window, including resizer, statusBar, etc.
  `Window`
  `setShowHeader(Boolean showHeader)`
  If true, show a `header` for this Window.
  `Window`
  `setShowHeaderBackground(Boolean showHeaderBackground)`
  Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
  If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
  `Window`
  `setShowHeaderIcon(Boolean showHeaderIcon)`
  If true, we show an icon on the left in the header.
  `Window`
  `setShowMaximizeButton(Boolean showMaximizeButton)`
  If true, show a maximize button in the header - clicking it maximizes the Window
  If this method is called after the component has been drawn/initialized: Dynamically update `showMaximizeButton` to show / hide the maximizeButton
  `Window`
  `setShowMinimizeButton(Boolean showMinimizeButton)`
  If true, show a minimize button in the header--clicking it minimizes the Window.
  `Window`
  `setShowModalMask(Boolean showModalMask)`
  If true, displays a translucent mask over the rest of the page when a modal window is displayed.
  `Window`
  `setShowResizer(Boolean showResizer)`
  If true, show a button in the lower right corner that allows users to resize the Window.
  `Window`
  `setShowShadow(Boolean showShadow)`
  Whether to show a drop shadow for this Canvas.
  `Window`
  `setShowStatusBar(Boolean showStatusBar)`
  If true, show a statusBar for this Window, including resizer.
  `Window`
  `setShowTitle(Boolean showTitle)`
  Show a title (typically just text) on the header for this window.
  `Window`
  `setSrc(String src)`
  A URL to load as content for the Window's body.
  `Window`
  `setStatus(String status)`
  Text to show in the status bar of the window (if one is visible)
  If this method is called after the component has been drawn/initialized: Sets the text in the status bar of the window, redrawing if necessary.
  `void`
  `setTitle(String title)`
  Title for this Window, shown if `showTitle` is true in the `header` (if drawn).
  `Window`
  `setUseBackMask(Boolean useBackMask)`
  By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9.
  `Boolean`
  `shouldDismissOnEscape()`
  Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
  Default behavior: if `dismissOnEscape` is set, just return it.

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### Window

    public Window()

  - ### Window

    public Window(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static Window getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `VLayout`

  - ### setAnimateMinimize

    public Window setAnimateMinimize(Boolean animateMinimize)
    Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?

    Note : This is an advanced setting

    Parameters:
      `animateMinimize` - New animateMinimize value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`
      - Window Minimize Example

  - ### getAnimateMinimize

    public Boolean getAnimateMinimize()
    Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
    Returns:
      Current animateMinimize value. Default value is null
    See Also:
      - `Appearance overview and related methods`
      - Window Minimize Example

  - ### setAutoCenter

    public Window setAutoCenter(Boolean autoCenter)
    If true, this Window widget will automatically be centered on the page when shown. If false, it will show up in the last position it was placed (either programmatically, or by user interaction).

    Note: If an auto-centering Window is either programmatically moved or dragged by an end user, auto-centering behavior is automatically turned off. To manually center a Window, you can use `centerInPage()`. Auto-centering will also be disabled if you pass an explicit `left` or `top` value at create time.
    If this method is called after the component has been drawn/initialized: Setter for the `autoCenter` attribute.

    Parameters:
      `autoCenter` - new value for autoCenter. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getAutoCenter

    public Boolean getAutoCenter()
    If true, this Window widget will automatically be centered on the page when shown. If false, it will show up in the last position it was placed (either programmatically, or by user interaction).

    Note: If an auto-centering Window is either programmatically moved or dragged by an end user, auto-centering behavior is automatically turned off. To manually center a Window, you can use `centerInPage()`. Auto-centering will also be disabled if you pass an explicit `left` or `top` value at create time.

    Returns:
      Current autoCenter value. Default value is false
    See Also:
      - `Appearance overview and related methods`

  - ### setAutoSize

    public Window setAutoSize(Boolean autoSize)
    If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
    If this method is called after the component has been drawn/initialized: Setter for `autoSize`
    Parameters:
      `autoSize` - true if the window should auto-size to its content. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`
      - Auto Size Example

  - ### getAutoSize

    public Boolean getAutoSize()
    If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
    Returns:
      Current autoSize value. Default value is false
    See Also:
      - `Appearance overview and related methods`
      - Auto Size Example

  - ### getBody

    public Canvas getBody() throws IllegalStateException
    Body of the Window, where `contained components` or `loaded content` is shown.

    The following `passthroughs` apply:

    - `bodyStyle` for the `Canvas.styleName`
    - `printBodyStyle` for the `styleName` to use when printing
    - `bodyColor` / `hiliteBodyColor` for the `Canvas.backgroundColor`

    This component is an AutoChild named "body". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current body value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setBodyColor

    public Window setBodyColor(String bodyColor)
    Color of the Window body. Overrides the background color specified in the style.
    If this method is called after the component has been drawn/initialized: Setter for `bodyColor`.
    Parameters:
      `bodyColor` - new `backgroundColor` for the `body`. Default value is "#FFFFFF"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `flash()`
      - `CSSColor`
      - `Appearance overview and related methods`

  - ### getBodyColor

    public String getBodyColor()
    Color of the Window body. Overrides the background color specified in the style.
    Returns:
      Current bodyColor value. Default value is "#FFFFFF"
    See Also:
      - `flash()`
      - `CSSColor`
      - `Appearance overview and related methods`

  - ### setBodyDefaults

    public Window setBodyDefaults(Map bodyDefaults)
    Default properties for the body of the Window
    You can change the class-level bodyDefaults for all Windows by changing this item or set instance.body to be another object of properties to override for your instance only

    Note : This is an advanced setting

    Parameters:
      `bodyDefaults` - New bodyDefaults value. Default value is ...
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### setBodyStyle

    public Window setBodyStyle(String bodyStyle)
    Style of the Window body.
    If this method is called after the component has been drawn/initialized: Setter for `bodyStyle`.
    Parameters:
      `bodyStyle` - new `styleName` for the `body`. Default value is "windowBody"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getBodyStyle

    public String getBodyStyle()
    Style of the Window body.
    Returns:
      Current bodyStyle value. Default value is "windowBody"
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setBringToFrontOnMouseUp

    public Window setBringToFrontOnMouseUp(boolean bringToFrontOnMouseUp)
    Should this window automatically be shown at the top of the page's z-order and be brought to front via `Canvas.bringToFront()` whenever the user clicks it?

    If `isModal` is true for this window, this setting will have no effect - we always bring the window to the front on initial display and on mouseDown. By default we also do this for non-modal windows (which matches user expectation for most standard interfaces - think of switching between OS-level application windows), but this may be disabled for cases where it is not appropriate by setting this attribute to `false`

    Parameters:
      `bringToFrontOnMouseUp` - New bringToFrontOnMouseUp value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls

  - ### getBringToFrontOnMouseUp

    public boolean getBringToFrontOnMouseUp()
    Should this window automatically be shown at the top of the page's z-order and be brought to front via `Canvas.bringToFront()` whenever the user clicks it?

    If `isModal` is true for this window, this setting will have no effect - we always bring the window to the front on initial display and on mouseDown. By default we also do this for non-modal windows (which matches user expectation for most standard interfaces - think of switching between OS-level application windows), but this may be disabled for cases where it is not appropriate by setting this attribute to `false`

    Returns:
      Current bringToFrontOnMouseUp value. Default value is true

  - ### setCanDragReposition

    public Window setCanDragReposition(Boolean canDragReposition)
    If true, this Window may be moved around by the user by dragging on the Window header. Note that if the header is not showing, the Window can't be drag-repositioned regardless of this setting.
    Overrides:
      `setCanDragReposition` in class `Canvas`
    Parameters:
      `canDragReposition` - New canDragReposition value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `setShowHeader(java.lang.Boolean)`

  - ### getCanDragReposition

    public Boolean getCanDragReposition()
    If true, this Window may be moved around by the user by dragging on the Window header. Note that if the header is not showing, the Window can't be drag-repositioned regardless of this setting.
    Overrides:
      `getCanDragReposition` in class `Canvas`
    Returns:
      Current canDragReposition value. Default value is true
    See Also:
      - `getShowHeader()`

  - ### setCanDragResize

    public Window setCanDragResize(Boolean canDragResize)
    Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
    Overrides:
      `setCanDragResize` in class `Canvas`
    Parameters:
      `canDragResize` - New canDragResize value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `setShowResizer(java.lang.Boolean)`

  - ### getCanDragResize

    public Boolean getCanDragResize()
    Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
    Overrides:
      `getCanDragResize` in class `Canvas`
    Returns:
      Current canDragResize value. Default value is false
    See Also:
      - `getShowResizer()`

  - ### setCanFocusInHeaderButtons

    public Window setCanFocusInHeaderButtons(Boolean canFocusInHeaderButtons)
    If true, the user can give the header buttons focus (see `minimizeButton`, `maximizeButton`, `restoreButton` and `closeButton`).

    Note : This is an advanced setting

    Parameters:
      `canFocusInHeaderButtons` - New canFocusInHeaderButtons value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Focus`

  - ### getCanFocusInHeaderButtons

    public Boolean getCanFocusInHeaderButtons()
    If true, the user can give the header buttons focus (see `minimizeButton`, `maximizeButton`, `restoreButton` and `closeButton`).
    Returns:
      Current canFocusInHeaderButtons value. Default value is false
    See Also:
      - `Focus`

  - ### getCloseButton

    public ImgButton getCloseButton() throws IllegalStateException
    Button show in the header that will close this Window by calling `Window.closeClick()`.

    This component is an AutoChild named "closeButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current closeButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setContentLayout

    public Window setContentLayout(ContentLayoutPolicy contentLayout)
    The layout policy that should be used for widgets within the Window body.

    See `ContentLayoutPolicy` and `bodyConstructor` for details.

    Note : This is an advanced setting

    Parameters:
      `contentLayout` - New contentLayout value. Default value is "vertical"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getContentLayout

    public ContentLayoutPolicy getContentLayout()
    The layout policy that should be used for widgets within the Window body.

    See `ContentLayoutPolicy` and `bodyConstructor` for details.

    Returns:
      Current contentLayout value. Default value is "vertical"
    See Also:
      - `Appearance overview and related methods`

  - ### setContentsType

    public Window setContentsType(String contentsType) throws IllegalStateException
    If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.

    This is similar to the `HTMLFlow.contentsType` property - be sure to read the HTMLFlow documentation to understand circumstances where contentsType:"page" is unsafe and not recommended.

    Parameters:
      `contentsType` - New contentsType value. Default value is "page"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `setSrc(java.lang.String)`
      - `Appearance overview and related methods`

  - ### getContentsType

    public String getContentsType()
    If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.

    This is similar to the `HTMLFlow.contentsType` property - be sure to read the HTMLFlow documentation to understand circumstances where contentsType:"page" is unsafe and not recommended.

    Returns:
      Current contentsType value. Default value is "page"
    See Also:
      - `getSrc()`
      - `Appearance overview and related methods`

  - ### setDefaultMinimizeHeight

    public Window setDefaultMinimizeHeight(int defaultMinimizeHeight)
    If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
    If there is no header, the `defaultMinimizeHeight` will be used instead.

    Note : This is an advanced setting

    Parameters:
      `defaultMinimizeHeight` - New defaultMinimizeHeight value. Default value is 16
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getDefaultMinimizeHeight

    public int getDefaultMinimizeHeight()
    If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
    If there is no header, the `defaultMinimizeHeight` will be used instead.
    Returns:
      Current defaultMinimizeHeight value. Default value is 16
    See Also:
      - `Appearance overview and related methods`

  - ### setDismissOnEscape

    public Window setDismissOnEscape(Boolean dismissOnEscape)
    Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
    Windows with this setting will dismiss on Escape keypresses in any of the following cases:
    - The window or one of its descendants has focus (and does not cancel the Escape keypress)
    - The window is `modal`, and not itself masked. This ensures that focus is not on some unrelated element on the page.

    If unset default behavior depends on whether a close / cancel button is visible for this item.

    Parameters:
      `dismissOnEscape` - New dismissOnEscape value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `shouldDismissOnEscape()`

  - ### getDismissOnEscape

    public Boolean getDismissOnEscape()
    Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
    Windows with this setting will dismiss on Escape keypresses in any of the following cases:
    - The window or one of its descendants has focus (and does not cancel the Escape keypress)
    - The window is `modal`, and not itself masked. This ensures that focus is not on some unrelated element on the page.

    If unset default behavior depends on whether a close / cancel button is visible for this item.

    Returns:
      Current dismissOnEscape value. Default value is null
    See Also:
      - `shouldDismissOnEscape()`

  - ### setDismissOnOutsideClick

    public Window setDismissOnOutsideClick(Boolean dismissOnOutsideClick)
    If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
    Note: Applies only to modal windows.
    Parameters:
      `dismissOnOutsideClick` - New dismissOnOutsideClick value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `setIsModal(java.lang.Boolean)`

  - ### getDismissOnOutsideClick

    public Boolean getDismissOnOutsideClick()
    If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
    Note: Applies only to modal windows.
    Returns:
      Current dismissOnOutsideClick value. Default value is false
    See Also:
      - `getIsModal()`

  - ### setEditProxyConstructor

    public Window setEditProxyConstructor(String editProxyConstructor) throws IllegalStateException
    Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    Overrides:
      `setEditProxyConstructor` in class `Layout`
    Parameters:
      `editProxyConstructor` - New editProxyConstructor value. Default value is "WindowEditProxy"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCClassName`

  - ### getEditProxyConstructor

    public String getEditProxyConstructor()
    Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    Overrides:
      `getEditProxyConstructor` in class `Layout`
    Returns:
      Current editProxyConstructor value. Default value is "WindowEditProxy"
    See Also:
      - `SCClassName`

  - ### setFillSpaceStyleName

    public Window setFillSpaceStyleName(String fillSpaceStyleName) throws IllegalStateException
    Alternative style for the window used whenever `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges.
    Parameters:
      `fillSpaceStyleName` - New fillSpaceStyleName value. Default value is "windowBackgroundFill"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`

  - ### getFillSpaceStyleName

    public String getFillSpaceStyleName()
    Alternative style for the window used whenever `placement` settings indicate the menu will be filling a portion of the screen or a panel. Generally this alternative style should not have rounded or excessively large edges.
    Returns:
      Current fillSpaceStyleName value. Default value is "windowBackgroundFill"
    See Also:
      - `CSSStyleName`

  - ### getFooter

    public HLayout getFooter() throws IllegalStateException
    Optional footer for the window, providing space for controls such as the resizer and status bar.

    This component is an AutoChild named "footer". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current footer value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setFooterHeight

    public Window setFooterHeight(int footerHeight) throws IllegalStateException
    The height of the footer, in pixels.
    Parameters:
      `footerHeight` - New footerHeight value. Default value is 18
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `Appearance overview and related methods`

  - ### getFooterHeight

    public int getFooterHeight()
    The height of the footer, in pixels.
    Returns:
      Current footerHeight value. Default value is 18
    See Also:
      - `Appearance overview and related methods`

  - ### getHeader

    public HLayout getHeader() throws IllegalStateException
    Header for the Window, based on an HLayout. The header contains the title and some standard controls for the window, which may be configured via `headerControls`.

    The following `passthroughs` apply:

    - `headerStyle` for `Canvas.styleName`
    - `printHeaderStyle` for the `styleName` to use when printing.

    This component is an AutoChild named "header". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current header value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getHeaderBackground

    public Img getHeaderBackground() throws IllegalStateException
    Img background component for the header, for gradient or image-based display

    This component is an AutoChild named "headerBackground". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current headerBackground value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getHeaderIcon

    public Img getHeaderIcon() throws IllegalStateException
    Header icon shown at left end of header by default.

    This component is an AutoChild named "headerIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current headerIcon value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setHeaderIconDefaults

    public Window setHeaderIconDefaults(Map headerIconDefaults)
    This is an object literal property block specifying the various properties of the headerIcon - the icon that appears at the top left of the window and is by default the Isomorphic logo. Overrideable defaults are as follows:
    - width - default to `16` and specifies the width of the headerIcon.
    - height - default to `14` and specifies the height of the headerIcon.
    - src - defaults to `"[SKIN]/Window/minimize.gif"` and specifies the image for the headerIcon.
    You can override the the above properties by calling Class.changeDefaults().

    Note : This is an advanced setting

    Parameters:
      `headerIconDefaults` - New headerIconDefaults value. Default value is ...
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getHeaderLabel

    public Label getHeaderLabel() throws IllegalStateException
    Label that shows Window title in header.

    The following `passthrough` applies: `title` for `Label.contents`.

    This component is an AutoChild named "headerLabel". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current headerLabel value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setHeaderSrc

    public Window setHeaderSrc(String headerSrc)
    If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.

    Note : This is an advanced setting

    Parameters:
      `headerSrc` - New headerSrc value. Default value is "[SKIN]Window/headerGradient.gif" | null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `SCImgURL`
      - `Appearance overview and related methods`

  - ### getHeaderSrc

    public String getHeaderSrc()
    If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
    Returns:
      Current headerSrc value. Default value is "[SKIN]Window/headerGradient.gif" | null
    See Also:
      - `SCImgURL`
      - `Appearance overview and related methods`

  - ### setHeaderStyle

    public Window setHeaderStyle(String headerStyle)
    Style for the Window header.
    If this method is called after the component has been drawn/initialized: Setter for `headerStyle`.

    Note : This is an advanced setting

    Parameters:
      `headerStyle` - new `styleName` for the `header`. Default value is "WindowHeader"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getHeaderStyle

    public String getHeaderStyle()
    Style for the Window header.
    Returns:
      Current headerStyle value. Default value is "WindowHeader"
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setHiliteBodyColor

    public Window setHiliteBodyColor(String hiliteBodyColor)
    Highlight color for the Window body (shown when the body is flashed).
    If this method is called after the component has been drawn/initialized: Setter for `hiliteBodyColor`.
    Parameters:
      `hiliteBodyColor` - new `hiliteBodyColor`. Default value is "#EEEEEE"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `flash()`
      - `CSSColor`
      - `Appearance overview and related methods`

  - ### getHiliteBodyColor

    public String getHiliteBodyColor()
    Highlight color for the Window body (shown when the body is flashed).
    Returns:
      Current hiliteBodyColor value. Default value is "#EEEEEE"
    See Also:
      - `flash()`
      - `CSSColor`
      - `Appearance overview and related methods`

  - ### setHiliteHeaderSrc

    public Window setHiliteHeaderSrc(String hiliteHeaderSrc)
    If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`

    Note : This is an advanced setting

    Parameters:
      `hiliteHeaderSrc` - New hiliteHeaderSrc value. Default value is "[SKIN]Window/headerGradient_hilite.gif" | null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `SCImgURL`
      - `Appearance overview and related methods`

  - ### getHiliteHeaderSrc

    public String getHiliteHeaderSrc()
    If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
    Returns:
      Current hiliteHeaderSrc value. Default value is "[SKIN]Window/headerGradient_hilite.gif" | null
    See Also:
      - `SCImgURL`
      - `Appearance overview and related methods`

  - ### setHiliteHeaderStyle

    public Window setHiliteHeaderStyle(String hiliteHeaderStyle)
    Highlight style for the Window header. Displayed when a window is `flashed`

    Note : This is an advanced setting

    Parameters:
      `hiliteHeaderStyle` - New hiliteHeaderStyle value. Default value is "WindowHeader"
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getHiliteHeaderStyle

    public String getHiliteHeaderStyle()
    Highlight style for the Window header. Displayed when a window is `flashed`
    Returns:
      Current hiliteHeaderStyle value. Default value is "WindowHeader"
    See Also:
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setIsModal

    public Window setIsModal(Boolean isModal)
    If true, when shown this Window will intercept and block events to all other existing components on the page.

    Use `showModalMask` to darken all other elements on the screen when a modal dialog is showing.

    Chained modal windows - that is, modal windows that launch other modal windows - are allowed. You can accomplish this by simply creating a second modal Window while a modal Window is showing.

    Note only top-level Windows (Windows without parents) can be modal.

    Parameters:
      `isModal` - New isModal value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - Modality Example

  - ### getIsModal

    public Boolean getIsModal()
    If true, when shown this Window will intercept and block events to all other existing components on the page.

    Use `showModalMask` to darken all other elements on the screen when a modal dialog is showing.

    Chained modal windows - that is, modal windows that launch other modal windows - are allowed. You can accomplish this by simply creating a second modal Window while a modal Window is showing.

    Note only top-level Windows (Windows without parents) can be modal.

    Returns:
      Current isModal value. Default value is false
    See Also:
      - Modality Example

  - ### getMaximizeButton

    public ImgButton getMaximizeButton() throws IllegalStateException
    Button that will make this Window fill the browser via `maximize()`.

    This component is an AutoChild named "maximizeButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current maximizeButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setMaximized

    public Window setMaximized(Boolean maximized)
    Is this window maximized. If true at init time, the window will be drawn maximized. To set this property at runtime use `maximize()` or `restore()`.
    Parameters:
      `maximized` - New maximized value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getMaximized

    public Boolean getMaximized()
    Is this window maximized. If true at init time, the window will be drawn maximized. To set this property at runtime use `maximize()` or `restore()`.
    Returns:
      Current maximized value. Default value is false
    See Also:
      - `Appearance overview and related methods`

  - ### setMinimizeAcceleration

    public Window setMinimizeAcceleration(AnimationAcceleration minimizeAcceleration)
    Default acceleration function for performing an animated minimize / maximize. If unset, `this.animateAcceleration` will be used by default instead

    Note : This is an advanced setting

    Parameters:
      `minimizeAcceleration` - New minimizeAcceleration value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getMinimizeAcceleration

    public AnimationAcceleration getMinimizeAcceleration()
    Default acceleration function for performing an animated minimize / maximize. If unset, `this.animateAcceleration` will be used by default instead
    Returns:
      Current minimizeAcceleration value. Default value is null
    See Also:
      - `Appearance overview and related methods`

  - ### getMinimizeButton

    public ImgButton getMinimizeButton() throws IllegalStateException
    ImgButton shown in the header that will minimize this Window by calling `minimize()`.

    This component is an AutoChild named "minimizeButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current minimizeButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setMinimized

    public Window setMinimized(Boolean minimized)
    Is this window minimized. If true at init time, the window will be drawn minimized. To set this property at runtime use `minimize()` or `restore()`.
    Parameters:
      `minimized` - New minimized value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getMinimized

    public Boolean getMinimized()
    Is this window minimized. If true at init time, the window will be drawn minimized. To set this property at runtime use `minimize()` or `restore()`.
    Returns:
      Current minimized value. Default value is false
    See Also:
      - `Appearance overview and related methods`

  - ### setMinimizeHeight

    public Window setMinimizeHeight(Integer minimizeHeight)
    Height for the window when minimized. If unset the window will shrink to the height of the header, if present, otherwise `this.defaultMinimizeHeight`

    Note : This is an advanced setting

    Parameters:
      `minimizeHeight` - New minimizeHeight value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getMinimizeHeight

    public Integer getMinimizeHeight()
    Height for the window when minimized. If unset the window will shrink to the height of the header, if present, otherwise `this.defaultMinimizeHeight`
    Returns:
      Current minimizeHeight value. Default value is null
    See Also:
      - `Appearance overview and related methods`

  - ### setMinimizeTime

    public Window setMinimizeTime(Integer minimizeTime)
    If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.

    Note : This is an advanced setting

    Parameters:
      `minimizeTime` - New minimizeTime value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`
      - Window Minimize Example

  - ### getMinimizeTime

    public Integer getMinimizeTime()
    If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
    Returns:
      Current minimizeTime value. Default value is null
    See Also:
      - `Appearance overview and related methods`
      - Window Minimize Example

  - ### getModalMask

    public Canvas getModalMask() throws IllegalStateException
    A ScreenSpan instance used to darken the rest of a page when a modal window is active. To use, set `showModalMask` to true, add a CSS style "modalMask" to the active skin (generally with background-color set), and adjust `modalMaskOpacity`.

    This component is an AutoChild named "modalMask". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current modalMask value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.
    See Also:
      - `Appearance overview and related methods`

  - ### setModalMaskOpacity

    public Window setModalMaskOpacity(int modalMaskOpacity) throws IllegalStateException
    Controls the opacity of the modal mask displayed behind modal windows.
    Parameters:
      `modalMaskOpacity` - New modalMaskOpacity value. Default value is 50
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `com.smartgwt.client.widgets.Window#setModalMask`
      - `Appearance overview and related methods`

  - ### getModalMaskOpacity

    public int getModalMaskOpacity()
    Controls the opacity of the modal mask displayed behind modal windows.
    Returns:
      Current modalMaskOpacity value. Default value is 50
    See Also:
      - `getModalMask()`
      - `Appearance overview and related methods`

  - ### setModalMaskStyle

    public Window setModalMaskStyle(String modalMaskStyle) throws IllegalStateException
    Specifies the CSS style for the modal mask.
    Parameters:
      `modalMaskStyle` - New modalMaskStyle value. Default value is "modalMask"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `com.smartgwt.client.widgets.Window#setModalMask`
      - `Appearance overview and related methods`

  - ### getModalMaskStyle

    public String getModalMaskStyle()
    Specifies the CSS style for the modal mask.
    Returns:
      Current modalMaskStyle value. Default value is "modalMask"
    See Also:
      - `getModalMask()`
      - `Appearance overview and related methods`

  - ### setOpacity

    public Window setOpacity(Integer opacity)
    Renders the widget to be partly transparent. A widget's opacity property may be set to any number between 0 (transparent) to 100 (opaque). Null means don't specify opacity directly, 100 is fully opaque. Note that heavy use of opacity may have a performance impact on some older browsers.

    In older versions of Internet Explorer (Pre IE9 / HTML5), opacity is achieved through proprietary filters. If `filters have been disabled` within this application developers must set `Canvas.useOpacityFilter` to true for specific components on which opacity support is required.

    Also note that opacity is incompatible with `backMasks`, and that this property is enabled by default for Window instances.

    Note : This is an advanced setting

    Overrides:
      `setOpacity` in class `Canvas`
    Parameters:
      `opacity` - New opacity value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Cues overview and related methods`

  - ### getOpacity

    public Integer getOpacity()
    Renders the widget to be partly transparent. A widget's opacity property may be set to any number between 0 (transparent) to 100 (opaque). Null means don't specify opacity directly, 100 is fully opaque. Note that heavy use of opacity may have a performance impact on some older browsers.

    In older versions of Internet Explorer (Pre IE9 / HTML5), opacity is achieved through proprietary filters. If `filters have been disabled` within this application developers must set `Canvas.useOpacityFilter` to true for specific components on which opacity support is required.

    Also note that opacity is incompatible with `backMasks`, and that this property is enabled by default for Window instances.

    Overrides:
      `getOpacity` in class `Canvas`
    Returns:
      Current opacity value. Default value is null
    See Also:
      - `Cues overview and related methods`

  - ### setPlacement

    public Window setPlacement(PanelPlacement placement) throws IllegalStateException
    Where should the window be placed on the screen? Valid settings include `"fillScreen"`, `"fillPanel"`, `"halfScreen"` and `"none"`

    If not explicitly specified, default is to use `PanelPlacement` "fillScreen" if `isHandset`, and "none" for non-handset devices.

    If `window.placement` is something other than `"none"`, sizing and positioning settings (either explicit left, top, width, height settings or the `autoCenter` and `autoSize` features) will have no effect.

    Parameters:
      `placement` - New placement value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getPlacement

    public PanelPlacement getPlacement()
    Where should the window be placed on the screen? Valid settings include `"fillScreen"`, `"fillPanel"`, `"halfScreen"` and `"none"`

    If not explicitly specified, default is to use `PanelPlacement` "fillScreen" if `isHandset`, and "none" for non-handset devices.

    If `window.placement` is something other than `"none"`, sizing and positioning settings (either explicit left, top, width, height settings or the `autoCenter` and `autoSize` features) will have no effect.

    Returns:
      Current placement value. Default value is null

  - ### setPrintBodyStyle

    public Window setPrintBodyStyle(String printBodyStyle) throws IllegalStateException
    Style for the Window body in printed output.
    Parameters:
      `printBodyStyle` - New printBodyStyle value. Default value is "printHeader"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`

  - ### getPrintBodyStyle

    public String getPrintBodyStyle()
    Style for the Window body in printed output.
    Returns:
      Current printBodyStyle value. Default value is "printHeader"
    See Also:
      - `CSSStyleName`

  - ### setPrintHeaderStyle

    public Window setPrintHeaderStyle(String printHeaderStyle) throws IllegalStateException
    CSS Style for header in printed output
    Parameters:
      `printHeaderStyle` - New printHeaderStyle value. Default value is "printHeader"
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`

  - ### getPrintHeaderStyle

    public String getPrintHeaderStyle()
    CSS Style for header in printed output
    Returns:
      Current printHeaderStyle value. Default value is "printHeader"
    See Also:
      - `CSSStyleName`

  - ### setResizeFrom

    public Window setResizeFrom(EdgeName... resizeFrom)
    When drag resizing is enabled via `canDragResize`, restricts resizes to only certain edges or corners.

    This property on `Window` overrides the default defined by `Canvas.resizeFrom`.

    Note : This is an advanced setting

    Overrides:
      `setResizeFrom` in class `Canvas`
    Parameters:
      `resizeFrom` - New resizeFrom value. Default value is ["R","B","BR"]
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Drag and Drop`

  - ### getResizeFrom

    public EdgeName[] getResizeFrom()
    When drag resizing is enabled via `canDragResize`, restricts resizes to only certain edges or corners.

    This property on `Window` overrides the default defined by `Canvas.resizeFrom`.

    Overrides:
      `getResizeFrom` in class `Canvas`
    Returns:
      Current resizeFrom value. Default value is ["R","B","BR"]
    See Also:
      - `Drag and Drop`

  - ### getResizer

    public ImgButton getResizer() throws IllegalStateException
    ImgButton-based resizer, shown in the footer.

    This component is an AutoChild named "resizer". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current resizer value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getRestoreButton

    public ImgButton getRestoreButton() throws IllegalStateException
    ImgButton that restores the Window via `restore()`.

    This component is an AutoChild named "restoreButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current restoreButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setShowBody

    public Window setShowBody(Boolean showBody)
    If true, draw the body contents when this Window is drawn.

    Note : This is an advanced setting

    Parameters:
      `showBody` - New showBody value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowBody

    public Boolean getShowBody()
    If true, draw the body contents when this Window is drawn.
    Returns:
      Current showBody value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowCloseButton

    public Window setShowCloseButton(Boolean showCloseButton)
    If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick()`.
    If this method is called after the component has been drawn/initialized: Dynamically update `showCloseButton` to show / hide the closeButton
    Parameters:
      `showCloseButton` - New showCloseButton value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowCloseButton

    public Boolean getShowCloseButton()
    If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick()`.
    Returns:
      Current showCloseButton value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowEdges

    public Window setShowEdges(Boolean showEdges) throws IllegalStateException
    `showEdges` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.
    Overrides:
      `setShowEdges` in class `Canvas`
    Parameters:
      `showEdges` - New showEdges value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - Edges Example

  - ### getShowEdges

    public Boolean getShowEdges()
    `showEdges` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.
    Overrides:
      `getShowEdges` in class `Canvas`
    Returns:
      Current showEdges value. Default value is null
    See Also:
      - Edges Example

  - ### setShowFooter

    public Window setShowFooter(Boolean showFooter)
    If true, show a footer for this Window, including resizer, statusBar, etc. This setting is commonly overridden for skinning purposes.
    Parameters:
      `showFooter` - New showFooter value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`
      - Footer Example

  - ### getShowFooter

    public Boolean getShowFooter()
    If true, show a footer for this Window, including resizer, statusBar, etc. This setting is commonly overridden for skinning purposes.
    Returns:
      Current showFooter value. Default value is true
    See Also:
      - `Appearance overview and related methods`
      - Footer Example

  - ### setShowHeader

    public Window setShowHeader(Boolean showHeader) throws IllegalStateException
    If true, show a `header` for this Window.

    Note that in certain Smartclient skins `showHeaderBackground` may be set to `false` and the header's appearance implemented as part of the window's `edge media`. In this case suppressing the header can be achieved by overriding the edge media as well as setting this property to false. For example, to create a headerless window with a similar appearance to a `Menu` in the `TreeFrog` skin, the following attributes could be used:

               showHeader:false,
               edgeImage:"[SKIN]/Menu/m.png",
               edgeSize:10, edgeTop:17, edgeBottom:17,
               edgeCenterBackgroundColor:"#F7F7F7"

    Parameters:
      `showHeader` - New showHeader value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `Appearance overview and related methods`

  - ### getShowHeader

    public Boolean getShowHeader()
    If true, show a `header` for this Window.

    Note that in certain Smartclient skins `showHeaderBackground` may be set to `false` and the header's appearance implemented as part of the window's `edge media`. In this case suppressing the header can be achieved by overriding the edge media as well as setting this property to false. For example, to create a headerless window with a similar appearance to a `Menu` in the `TreeFrog` skin, the following attributes could be used:

               showHeader:false,
               edgeImage:"[SKIN]/Menu/m.png",
               edgeSize:10, edgeTop:17, edgeBottom:17,
               edgeCenterBackgroundColor:"#F7F7F7"

    Returns:
      Current showHeader value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowHeaderBackground

    public Window setShowHeaderBackground(Boolean showHeaderBackground) throws IllegalStateException
    Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
    If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.

    Note : This is an advanced setting

    Parameters:
      `showHeaderBackground` - New showHeaderBackground value. Default value is varies
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `Appearance overview and related methods`

  - ### getShowHeaderBackground

    public Boolean getShowHeaderBackground()
    Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
    If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
    Returns:
      Current showHeaderBackground value. Default value is varies
    See Also:
      - `Appearance overview and related methods`

  - ### setShowHeaderIcon

    public Window setShowHeaderIcon(Boolean showHeaderIcon)
    If true, we show an icon on the left in the header.
    If this method is called after the component has been drawn/initialized: Dynamically update `showHeaderIcon` to show / hide the headerIcon
    Parameters:
      `showHeaderIcon` - New showHeaderIcon value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowHeaderIcon

    public Boolean getShowHeaderIcon()
    If true, we show an icon on the left in the header.
    Returns:
      Current showHeaderIcon value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowMaximizeButton

    public Window setShowMaximizeButton(Boolean showMaximizeButton)
    If true, show a maximize button in the header - clicking it maximizes the Window
    If this method is called after the component has been drawn/initialized: Dynamically update `showMaximizeButton` to show / hide the maximizeButton
    Parameters:
      `showMaximizeButton` - New showMaximizeButton value. Default value is false
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowMaximizeButton

    public Boolean getShowMaximizeButton()
    If true, show a maximize button in the header - clicking it maximizes the Window
    Returns:
      Current showMaximizeButton value. Default value is false
    See Also:
      - `Appearance overview and related methods`

  - ### setShowMinimizeButton

    public Window setShowMinimizeButton(Boolean showMinimizeButton)
    If true, show a minimize button in the header--clicking it minimizes the Window.
    If this method is called after the component has been drawn/initialized: Dynamically update `showMinimizeButton` to show / hide the minimizeButton
    Parameters:
      `showMinimizeButton` - New showMinimizeButton value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowMinimizeButton

    public Boolean getShowMinimizeButton()
    If true, show a minimize button in the header--clicking it minimizes the Window.
    Returns:
      Current showMinimizeButton value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowModalMask

    public Window setShowModalMask(Boolean showModalMask) throws IllegalStateException
    If true, displays a translucent mask over the rest of the page when a modal window is displayed.
    Parameters:
      `showModalMask` - New showModalMask value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `com.smartgwt.client.widgets.Window#setModalMask`
      - `Appearance overview and related methods`

  - ### getShowModalMask

    public Boolean getShowModalMask()
    If true, displays a translucent mask over the rest of the page when a modal window is displayed.
    Returns:
      Current showModalMask value. Default value is null
    See Also:
      - `getModalMask()`
      - `Appearance overview and related methods`

  - ### setShowResizer

    public Window setShowResizer(Boolean showResizer)
    If true, show a button in the lower right corner that allows users to resize the Window. Note that the resizer will only be displayed if the footer is showing for the window (`showFooter`) and `canDragResize` is true.
    Parameters:
      `showResizer` - New showResizer value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowResizer

    public Boolean getShowResizer()
    If true, show a button in the lower right corner that allows users to resize the Window. Note that the resizer will only be displayed if the footer is showing for the window (`showFooter`) and `canDragResize` is true.
    Returns:
      Current showResizer value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowShadow

    public Window setShowShadow(Boolean showShadow) throws IllegalStateException
    Whether to show a drop shadow for this Canvas.

    Developers should be aware that the drop shadow is drawn outside the specified width and height of the widget meaning a widget with shadows takes up a little more space than it otherwise would. A full screen canvas with showShadow set to true as this would be likely to cause browser scrollbars to appear - developers can handle this by either setting this property to false on full-screen widgets, or by setting overflow to "hidden" on the <body> element browser-level scrolling is never intended to occur.

    `showShadow` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.

    Overrides:
      `setShowShadow` in class `Canvas`
    Parameters:
      `showShadow` - New showShadow value. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - Shadows Example

  - ### getShowShadow

    public Boolean getShowShadow()
    Whether to show a drop shadow for this Canvas.

    Developers should be aware that the drop shadow is drawn outside the specified width and height of the widget meaning a widget with shadows takes up a little more space than it otherwise would. A full screen canvas with showShadow set to true as this would be likely to cause browser scrollbars to appear - developers can handle this by either setting this property to false on full-screen widgets, or by setting overflow to "hidden" on the <body> element browser-level scrolling is never intended to occur.

    `showShadow` dynamically defaults to false when the `placement` setting indicates the Window will be filling a portion of the screen or a panel.

    Overrides:
      `getShowShadow` in class `Canvas`
    Returns:
      Current showShadow value. Default value is null
    See Also:
      - Shadows Example

  - ### setShowStatusBar

    public Window setShowStatusBar(Boolean showStatusBar)
    If true, show a statusBar for this Window, including resizer. Note that the status bar will only be displayed if the footer is showing for the window (`showFooter`).
    Parameters:
      `showStatusBar` - New showStatusBar value. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowStatusBar

    public Boolean getShowStatusBar()
    If true, show a statusBar for this Window, including resizer. Note that the status bar will only be displayed if the footer is showing for the window (`showFooter`).
    Returns:
      Current showStatusBar value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setShowTitle

    public Window setShowTitle(Boolean showTitle)
    Show a title (typically just text) on the header for this window.
    If this method is called after the component has been drawn/initialized: Updates whether the `title` is shown in the `header`. No impact unless the header is being shown. The header will be redrawn if necessary.
    Parameters:
      `showTitle` - new showTitle. Default value is true
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getShowTitle

    public Boolean getShowTitle()
    Show a title (typically just text) on the header for this window.
    Returns:
      Current showTitle value. Default value is true
    See Also:
      - `Appearance overview and related methods`

  - ### setSrc

    public Window setSrc(String src)
    A URL to load as content for the Window's body. If specified, this attribute will take precedence over the items attribute.

    Note that setting window.src is essentially a shortcut for setting `items` to a single HTMLflow with a specified `contentsURL`.
    If this method is called after the component has been drawn/initialized: Sets the URL of the contents to display in the body of the window, redrawing if necessary.

    Parameters:
      `src` - URL of new contents to be displayed in the window body. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `setContentsType(java.lang.String)`
      - `Appearance overview and related methods`

  - ### getSrc

    public String getSrc()
    A URL to load as content for the Window's body. If specified, this attribute will take precedence over the items attribute.

    Note that setting window.src is essentially a shortcut for setting `items` to a single HTMLflow with a specified `contentsURL`.

    Returns:
      Current src value. Default value is null
    See Also:
      - `getContentsType()`
      - `Appearance overview and related methods`

  - ### setStatus

    public Window setStatus(String status)
    Text to show in the status bar of the window (if one is visible)
    If this method is called after the component has been drawn/initialized: Sets the text in the status bar of the window, redrawing if necessary.
    Parameters:
      `status` - new text for the status bar. Default value is null
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Appearance overview and related methods`

  - ### getStatus

    public String getStatus()
    Text to show in the status bar of the window (if one is visible)
    Returns:
      Current status value. Default value is null
    See Also:
      - `Appearance overview and related methods`

  - ### getStatusBar

    public Canvas getStatusBar() throws IllegalStateException
    Simple Canvas-based status bar, shown in the footer. `setStatus()` can be used to show text here.

    This component is an AutoChild named "statusBar". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current statusBar value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setTitle

    public void setTitle(String title)
    Title for this Window, shown if `showTitle` is true in the `header` (if drawn).
    If this method is called after the component has been drawn/initialized: Sets the `title` that appears in the window `header`. The header will be redrawn if necessary.
    Overrides:
      `setTitle` in class `Canvas`
    Parameters:
      `title` - new title. Default value is "Untitled Window"
    See Also:
      - `HTMLString`
      - `Appearance overview and related methods`

  - ### getTitle

    public String getTitle()
    Title for this Window, shown if `showTitle` is true in the `header` (if drawn).
    Overrides:
      `getTitle` in class `Canvas`
    Returns:
      Current title value. Default value is "Untitled Window"
    See Also:
      - `HTMLString`
      - `Appearance overview and related methods`

  - ### setUseBackMask

    public Window setUseBackMask(Boolean useBackMask) throws IllegalStateException
    By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9. This is a workaround for a native browser issue whereby certain DOM elements such as `IFRAME`s (whether rendered within Smart GWT components via features such as `contentsURL` or explicitly written into the HTML of the page) will not be properly occluded by DOM elements which overlap them but have a higher z-index.

    A side-effect of this is that the `opacity` can not be modified for the entire window. Developers may disable the backmask in order to support opacity in IE versions less than 9 by setting this property to false, however you should be aware that in doing this there is a potential for the "burn through" problem described above.

    Note : This is an advanced setting

    Overrides:
      `setUseBackMask` in class `Canvas`
    Parameters:
      `useBackMask` - New useBackMask value. Default value is varies
    Returns:
      `Window` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUseBackMask

    public Boolean getUseBackMask()
    By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9. This is a workaround for a native browser issue whereby certain DOM elements such as `IFRAME`s (whether rendered within Smart GWT components via features such as `contentsURL` or explicitly written into the HTML of the page) will not be properly occluded by DOM elements which overlap them but have a higher z-index.

    A side-effect of this is that the `opacity` can not be modified for the entire window. Developers may disable the backmask in order to support opacity in IE versions less than 9 by setting this property to false, however you should be aware that in doing this there is a potential for the "burn through" problem described above.

    Overrides:
      `getUseBackMask` in class `Canvas`
    Returns:
      Current useBackMask value. Default value is varies

  - ### addMember

    public void addMember(Canvas newMember)
    Same as `Layout.addMember()`. Note that in order to add items to `body`, you use `addItem()` rather than `addMember`. Adding a member to a Window adds the member as a sibling to the header, body and other built-in Window subcomponents.
    Overrides:
      `addMember` in class `Layout`
    Parameters:
      `newMember` - the canvas object to be added to the layout
    See Also:
      - `Layout.addMembers(java.lang.Object[], int)`

  - ### addMember

    public void addMember(Canvas newMember, Integer position)
    Same as `Layout.addMember()`. Note that in order to add items to `body`, you use `addItem()` rather than `addMember`. Adding a member to a Window adds the member as a sibling to the header, body and other built-in Window subcomponents.
    Parameters:
      `newMember` - the canvas object to be added to the layout
      `position` - If passed, this specifies the insertion position between the existing members of the layout. If omitted, the canvas will be added at the last position
    See Also:
      - `Layout.addMembers(java.lang.Object[], int)`

  - ### centerInPage

    public void centerInPage()
    Centers the Window in the page. This is called automatically in window.show() if Window.autoCenter is true. Note - if the Window is a child of another widget, we center in the parent widget rather than centering in the page.
    See Also:
      - `getAutoCenter()`
      - `Appearance overview and related methods`

  - ### close

    public void close()
    Close this window. This method is fired by the default `Window.closeClick()` implementation. Default implementation will hide the window.

  - ### addCloseClickHandler

    public HandlerRegistration addCloseClickHandler(CloseClickHandler handler)
    Add a closeClick handler.

    Handles a click on the close button of this window. The default implementation calls `close()` and returns false to prevent bubbling of the click event.

    Developers may use `addCloseClickHandler()` to provide custom handling when the user clicks this button. Custom implementations may call `close()` to trigger the default behavior.

    Specified by:
      `addCloseClickHandler` in interface `HasCloseClickHandlers`
    Parameters:
      `handler` - the closeClick handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### flash

    public void flash()
    Makes the window header flash if it's visible; if there's no header, or the header is hidden, makes the window body flash instead.

    This method is executed when users click outside the bounds of a modal window so they'll notice that they have to do something with the window.

  - ### maximize

    public void maximize()
    Maximize the window. Fired when the user clicks the maximize button if `this.showMaximizeButton` is true.
    Default implementation moves the window to `0, 0` and resizes the window to `"100%"` on both axes, so it will fill the browser window (or the parent of the Window instance, if appropriate).
    If `animateMinimize` is true, the maximize will be animated. A restore button will be displayed in place of the maximize button when the window is maximized.

  - ### minimize

    public void minimize()
    Minimize the window. Fired when the user clicks the minimize button if `this.showMinimizeButton` is true.
    Default implementation shrinks the window to just the height of the header bar, hiding the body. If `animateMinimize` is true, the resize will be animated. A restore button will be displayed in place of the minimize button when the window is minimized.

  - ### addMaximizeClickHandler

    public HandlerRegistration addMaximizeClickHandler(MaximizeClickHandler handler)
    Add a maximizeClick handler.

    Notification method fired when the user clicks the 'maximize' button.

    Specified by:
      `addMaximizeClickHandler` in interface `HasMaximizeClickHandlers`
    Parameters:
      `handler` - the maximizeClick handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### addMinimizeClickHandler

    public HandlerRegistration addMinimizeClickHandler(MinimizeClickHandler handler)
    Add a minimizeClick handler.

    Notification method fired when the user clicks the 'minimize' button.

    Specified by:
      `addMinimizeClickHandler` in interface `HasMinimizeClickHandlers`
    Parameters:
      `handler` - the minimizeClick handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### addRestoreClickHandler

    public HandlerRegistration addRestoreClickHandler(RestoreClickHandler handler)
    Add a restoreClick handler.

    Notification method fired when the user clicks the 'restore' button.

    Specified by:
      `addRestoreClickHandler` in interface `HasRestoreClickHandlers`
    Parameters:
      `handler` - the restoreClick handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### restore

    public void restore()
    Restores the window to its specified height and width after a call to `minimize()` or `maximize()`. Called from a click on the restore button shown in place of the minimize or maximize button when the window is minimized or maximized.
    Resizing will occur as an animation if `animateMinimize` is true.

  - ### shouldDismissOnEscape

    public Boolean shouldDismissOnEscape()
    Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
    Default behavior: if `dismissOnEscape` is set, just return it. Otherwise return true if this window is showing a "close" control in the header (see `headerControls`).
    Returns:
      true if the window should be dismissed when the user hits escape

  - ### setDefaultProperties

    public static void setDefaultProperties(Window windowProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `windowProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### addItem

    public void addItem(Widget widget)
    Adds a widget to the window.
    Parameters:
      `widget` - the widget to be added

  - ### addItem

    public void addItem(Canvas component)
    Adds a widget to the window.
    Parameters:
      `component` - the widget to be added

  - ### removeItem

    public void removeItem(Canvas component)
    Removes a widget from the window.
    Parameters:
      `component` - the widget to be removed

  - ### setKeepInParentRect

    public Window setKeepInParentRect(Boolean keepInParentRect)
    If Window.canDragReposition or Window.canDragResize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)?

    Note: keepInParentRect affects only user drag interactions, not programmatic moves.
    Overrides:
      `setKeepInParentRect` in class `Canvas`
    Parameters:
      `keepInParentRect` - true to keepInParentRect
    Returns:
      `Window` instance, for chaining setter calls
    See Also:
      - `Drag and Drop`
      - Drag create Example

  - ### setHeaderIconProperties

    public void setHeaderIconProperties(Map headerIconProperties)

  - ### setHeaderIcon

    public void setHeaderIcon(String imgSrc)
    Sets the Window header icon.
    Parameters:
      `imgSrc` - the icon image source

  - ### setHeaderIcon

    public void setHeaderIcon(String imgSrc, int width, int height)
    Sets the Window header icon.
    Parameters:
      `imgSrc` - the icon image source
      `width` - the icon width. default 16
      `height` - the icon height. default 14

  - ### setHeaderControls

    public void setHeaderControls(Object... headerControls)
    Array of members to show in the Window header. The default value of headerControls is an Array of `HeaderControls` listing the standard header controls in their default order:
    headerControls : [HeaderControls.HEADER_ICON, HeaderControls.HEADER_LABEL, HeaderControls.MINIMIZE_BUTTON, HeaderControls.MAXIMIZE_BUTTON, HeaderControls.CLOSE_BUTTON]

    You can set headerControls to change the order of standard controls in the header. You can also omit standard controls this way, although it more efficient to use the related "show" property if available (eg Window.showMinimizeButton).
    By embedding a Canvas directly in this list you can add arbitrary additional controls to the header, for example, an additional button (eg return to dock) or a DynamicForm with various kinds of input controls. Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.
    Parameters:
      `headerControls` - an array containing either HeaderControl enums values or Canvas instances
    See Also:
      - `HeaderControls`

  - ### setFooterControls

    public void setFooterControls(Object... footerControls)
    Array of members to show in the Window footer. The default value of headerControls is an Array of `FooterControls` listing the standard footer controls in their default order:
    headerControls : [HeaderControls.SPACER, HeaderControls.RESIZER]

    You can set footerControls to change the order of standard controls in the footer. You can also omit standard controls this way, although it more efficient to use the related "show" property if available (eg Window.showResizer).
    By embedding a Canvas directly in this list you can add arbitrary additional controls to the footer.
    Note that the statusBar is not part of the set of footer controls - it is a separate canvas rendered behind all footer controls. If you include some custom status bar directly in the footerControls you may want to set +link{window.showFooter} to false. Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.
    Parameters:
      `footerControls` - an array containing either FooterControl enums values or Canvas instances
    See Also:
      - `FooterControls`

  - ### setKeepInParentRect

    public Window setKeepInParentRect(Rectangle rectangle)
    If Window.canDragReposition or Window.canDragRShowcaseDataesize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)? Can also be set to an array denoting an arbitrary Rectangle beyond which the window cannot be moved.
    Note: keepInParentRect affects only user drag interactions, not programmatic moves.
    Overrides:
      `setKeepInParentRect` in class `Canvas`
    Parameters:
      `rectangle` - the rectangle bounds
    Returns:
      `Window` instance, for chaining setter calls

  - ### getItems

    public Canvas[] getItems()
    The contents of the Window body. Can be specified three different ways:
    - an Array of Canvases that will become the children of the Window's body when it is initialized; the canvases in this array should be created, but not drawn (autodraw: false).
    - a single canvas that will become a child of the Window body.
    - a string that will be set as the body's contents.
    Returns:
      items

  - ### preloadImages

    public static void preloadImages()
    Preload primary window skin images

  - ### setContentLayout

    public void setContentLayout(String contentLayout)
    Deprecated.
    use the other `setContentLayout()`

    The layout policy that should be used for widgets within the Window body.

    Valid values are "vertical", "horizontal", or "none". If the body is a Layout, this controls how the items are stacked in the body by setting `Layout.vertical`. See `bodyConstructor` for details.

    Note : This is an advanced setting

    Parameters:
      `contentLayout` - Default value is "vertical"
    See Also:
      - `Appearance overview and related methods`

  - ### revealChild

    public void revealChild(String childID)
    Reveals the child Canvas passed in by showing it if it is currently hidden. Note, in the case of Window, "child Canvas" means widgets in the Window's "items" collection as well as real children (the children of a Window - ie, the elements of its "children" array - are its component parts like header and body) NOTE: This is an override point.
    Overrides:
      `revealChild` in class `Layout`
    Parameters:
      `childID` - the global ID of the child Canvas to reveal

  - ### revealChild

    public void revealChild(Canvas child)
    Reveals the child Canvas passed in by showing it if it is currently hidden. Note, in the case of Window, "child Canvas" means widgets in the Window's "items" collection as well as real children (the children of a Window - ie, the elements of its "children" array - are its component parts like header and body) NOTE: This is an override point.
    Overrides:
      `revealChild` in class `Layout`
    Parameters:
      `child` - the child Canvas to reveal

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(WindowLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `VLayout`